varying vec2 texCoord0;
varying vec3 normal;

varying vec4 V_lightPos;
varying vec4 V_light2Pos;
varying vec4 V_light3Pos;
varying float FogPower;

varying vec4 V_cameraPos;

uniform sampler2D decal;

uniform vec4 lightColor;
uniform vec4 light2Color;
uniform vec4 light3Color;

uniform vec3 lightOri;
uniform vec3 light2Ori;
uniform vec3 light3Ori;

uniform int lightFocus;
uniform int light2Focus;
uniform int light3Focus;


uniform vec3 cameraOri;
///
uniform vec4 ambientColor;
uniform vec4 matAmbient;
uniform vec4 matDiffuse;
uniform vec4 matSpecular;
uniform vec4 emissive;
uniform float shininess;


void main()
{
  // Re-normalize.
  vec3 n = normalize(normal);

  //Find tolight vectors
  vec3 l1 = normalize(V_lightPos.xyz);
  vec3 l2 = normalize(V_light2Pos.xyz);
  vec3 l3 = normalize(V_light3Pos.xyz);
    
  //vec3 eye = normalize(V_cameraPos.xyz);
  /////////
  // Get ambient.
  vec4 ambient = matAmbient * ambientColor;

  vec4 finalcol = vec4(vec3(0.0), 1.0);

  ////___1___///
  // Get diffuse.
  float diffuseLight = clamp(dot(n, l1), 0.0, 1.0);
  // Get attunation(simple)
  //float att= clamp(1.0 - dot(V_lightPos, V_lightPos) * 0.002, 0.0, 1.0);
  //att=pow(att,2.0);  

  // Get spot  
  float att2=pow(max(dot(normalize(lightOri),-l1),0.0),float(lightFocus))*4.0;  

  vec4 diffuse = matDiffuse * lightColor * diffuseLight *att2;

  /*// Get specular.
  vec3 halfVec = normalize(l1 + eye);
  float specularLight = pow(clamp(dot(n, halfVec), 0.0, 1.0), shininess);

  // No diffuse, no specular.
  vec4 specular = matSpecular * lightColor * specularLight;*/

  finalcol +=  ambient + diffuse +lightColor*emissive ;// + specular;
  ////___2___///
  // Get diffuse.
  diffuseLight = clamp(dot(n, l2), 0.0, 1.0);
  // Get attunation(simple)
  //att = clamp(1.0 - dot(V_light2Pos, V_light2Pos) * 0.002, 0.0, 1.0);
  
  // Get spot  
  att2=pow(max(dot(normalize(light2Ori),-l2),0.0),float(light2Focus))*4.0;  

  diffuse = matDiffuse * light2Color * diffuseLight *att2;

  finalcol += diffuse;
  /////////////
  ////___3___///
  // Get diffuse.
  diffuseLight = clamp(dot(n, l3), 0.0, 1.0);//clamp  max
  // Get attunation(simple)
  //att = clamp(1.0 - dot(V_light3Pos, V_light3Pos) * 0.002, 0.0, 1.0);
  
  // Get spot  
  att2=pow(max(dot(normalize(light3Ori),-l3),0.0),float(light3Focus))*4.0;  

  diffuse = matDiffuse * light3Color * diffuseLight  * att2;

  finalcol += diffuse;
  

  // Final lighting color.
  gl_FragColor = finalcol*texture2D(decal, texCoord0);
  gl_FragColor.w = 1.0;
}
